/*
 * CS5App.java -- John Conway's Game of Life
 *
 * PAIR PROGRAMMING PROBLEM
 *
 * Homework # 9
 * Problem  # 2
 *
 * Name(s):
 * Date:
 * Time spent:
 *
 * Comments:  
 * 
 *
 */

import java.awt.*;

class CS5App
{
	
	/* update proides rules for evolving one generation of life
     *
     * inputs: the last and next generations, each 2d arrays of ints
     * outputs: none (the next generation is set, however)
     * 
     * Note! For speed, the arrays are not checked to 
     *       be sure each cell contains a valid value!
     *       Be sure to assign only 0 or 1 to each cell.
     */
    public static void update(int[][] last, int[][] next)
	{
		for (int r=1 ; r<last.length-1 ; ++r)
		{
			for (int c=1 ; c<last[r].length-1 ; ++c)
			{
				// this is just a test -- in alternates
				// each cell on/off
				
				int old = last[r][c];
				
				if (old == 0)
				{
					next[r][c] = 1;
				}
				else
				{
					next[r][c] = 0;
				}
			}
		}	
	} // end of the update method
	
	
	
	/* updateMulti proides rules for evolving one generation of 
	 *             multi-species life
     *
     * inputs: the last and next generations, each 2d arrays of ints
     * outputs: none (the next generation is set, however)
     * 
     * Note! For speed, the arrays are not checked to 
     *       be sure each cell contains a valid value!
     *       Be sure to assign only 0 through your numSpecies.
     *
     *       In fact, you need to know what numSpecies you will use,
     *       because it's in main and not available here!
     *       (there are ways around this -- feel free to ask)
     */
	public static void updateMulti(int[][] last, int[][] next)
	{
		for (int r=1 ; r<last.length-1 ; ++r)
		{
			for (int c=1 ; c<last[r].length-1 ; ++c)
			{
				// nothing is here yet...
				; 
			} // end of the column for loop
		} // end of the row for loop
	} // end of the updateMulti method
	

    
    public static void main(String[] args)
    {
    	// parameters the user may choose	
    	int w = H.ni("Choose a width:");
    	int h = H.ni("Choose a height:");
    	int p = H.ni("Choose a pause time:");
    	
    	int numSpecies = 1;
    	int option = H.ni("Choose (0) Single or (1) Multi-species life:");
    	
    	if (option == 1)
    	{
    		numSpecies = H.ni("How many species (2-10)?");
    	}
    	
    	H.pl();
        
        // creates the graphical window or "canvas"
        GrCanvas lifeWindow = G.createCanvas();
        
        // creates an object named lifeObject with all of our choices
        GrLife lifeObject   = new GrLife(h,w,p,numSpecies,new CS5App());
        
        // chooses default colors (up to and including numSpecies)
        lifeObject.setColor(0, Color.white);    // empty is white by default
        lifeObject.setColor(1, Color.black);    // alive is black by default
        lifeObject.setColor(2, Color.red);      // 2nd species is red 
        
        // adds the life simulator to the window
        lifeWindow.add(lifeObject);
        
        // when in the life simulation window
        //
        // hit 'r' to run (or stop running)
        // hit 's' to step one generation at a time
        // hit 'q' to quit
        //
        // shift-click on a cell to change its contents
        
        
    } // end main

}	